#define	_WIN32_WINNT	0x500	// VC++ł͕K{
#include <windows.h>
#include <sddl.h>
#include <stdio.h>

struct SIDTYPENAME
{
	SID_NAME_USE type;
	const char *name;
} nametbl[] = {
	{ SidTypeUser,           "USER"},
	{ SidTypeGroup,          "GROUP"},
	{ SidTypeDomain,         "DOMAIN"},
	{ SidTypeAlias,          "ALIAS"},
	{ SidTypeWellKnownGroup, "WELL KNOWN GROUP"},
	{ SidTypeDeletedAccount, "DELETED ACCOUNT"},
	{ SidTypeInvalid,        "INVALID"},
	{ SidTypeComputer,       "COMPUTER"},
	{ SidTypeUnknown,        NULL}
};

void printSIDType( SID_NAME_USE use)
{
	SIDTYPENAME *ptr = nametbl;
	while( ptr->name != NULL){
		if( use == ptr->type){
			printf( ptr->name);
			return;
		}
		ptr++;
	}
	printf( "UNKNOWN");
}

void printAccessMask( DWORD mask)
{
	if( mask & GENERIC_READ)	printf( "GENERIC_READ ");
	if( mask & GENERIC_WRITE)	printf( "GENERIC_WRITE ");
	if( mask & GENERIC_EXECUTE)	printf( "GENERIC_EXECUTE ");
	if( mask & GENERIC_ALL)		printf( "GENERIC_ALL ");
}

int main( void)
{
	printf( "--- Current Default DACL ---\n");
	HANDLE hToken;
	// svZX̃ANZXEg[NEnh擾
	if( OpenProcessToken( GetCurrentProcess(), TOKEN_READ, &hToken) ){
		// ȒP̂߁CDACLɂ͑ΉĂȂ
		char buffer[1024];		// ǂݍ݃obt@
		TOKEN_DEFAULT_DACL *pDefdacl = (TOKEN_DEFAULT_DACL *)buffer;
		DWORD retlen = 0;
		// ftHgDACL̎擾
		if( GetTokenInformation( hToken, TokenDefaultDacl,  pDefdacl,
									sizeof(buffer), &retlen) ){
			if( pDefdacl->DefaultDacl != NULL){
				// ܂܂ACE̐
				int count = pDefdacl->DefaultDacl->AceCount;
				printf( "Number of ACEs: %d\n\n", count);
				
				// ACLwb_̒ォACEn܂
				ACE_HEADER *pHdr = (ACE_HEADER *)&pDefdacl->DefaultDacl[1];
				for( int i=0; i<count; i++){
					// ACEwb_`FbNāCACEƋ֎~ACE
					// e\
					if( pHdr->AceType == ACCESS_ALLOWED_ACE_TYPE
							|| pHdr->AceType == ACCESS_DENIED_ACE_TYPE){
						// ̂ƂCACEƋ֎~ACE͓\Ȃ̂
						// ACẼ|C^ŗANZXĂ܂
						ACCESS_ALLOWED_ACE *pHdr2 = (ACCESS_ALLOWED_ACE *)pHdr;
						
						printf( "ACE type: ");
						if( pHdr->AceType == ACCESS_ALLOWED_ACE_TYPE){
							printf( "Allowed ACE\n");
						}
						else{
							printf( "Denied ACE\n");
						}
						printf( "Access mask: ");
						printAccessMask( pHdr2->Mask);
						printf( "\n");
						
						// SID𕶎ɂĕ\
						LPTSTR sidstr;
						if( ConvertSidToStringSid( (PSID)&pHdr2->SidStart,
													&sidstr) ){
							printf( "SID:  %s\n", sidstr);
							LocalFree( sidstr);
						}
						
						// ͂蒷Oɂ͑ΉȂ
						char name[128], domain[128];
						DWORD namelen = sizeof(name);
						DWORD domlen = sizeof(domain);
						SID_NAME_USE use;
						if( LookupAccountSid( NULL, (PSID)&pHdr2->SidStart,
												name, &namelen,
												domain, &domlen, &use) ){
							printf( "name: %s\n", name);
							printf( "type: ");
							printSIDType( use);
							printf( "\n");
						}
						else{
							printf( "Cannot print a name and a type.\n");
						}
					}
					else{
						printf( "Other types of ACE\n");
					}
					printf( "\n");
					
					// ACEwb_ɈړB
					// ACE͉ϒȂ̂ŁCzƂĂ̓ANZXłȂB
					pHdr = ( ACE_HEADER *)( (char *)pHdr + pHdr->AceSize);
				}
			}
			else{
				printf( "there's no default dacl.\n");
			}
		}
		else{
			printf( "GetTokenInformation() error: %d.\n", GetLastError() );
		}
		CloseHandle( hToken);
	}
	else{
		printf( "OpenProcessToken() error: %d.\n", GetLastError() );
	}
	return 0;
}
