#include <windows.h>
#include <sddl.h>
#include <stdio.h>

struct SIDTYPENAME
{
	SID_NAME_USE type;
	const char *name;
} nametbl[] = {
	{ SidTypeUser,           "USER"},
	{ SidTypeGroup,          "GROUP"},
	{ SidTypeDomain,         "DOMAIN"},
	{ SidTypeAlias,          "ALIAS"},
	{ SidTypeWellKnownGroup, "WELL KNOWN GROUP"},
	{ SidTypeDeletedAccount, "DELETED ACCOUNT"},
	{ SidTypeInvalid,        "INVALID"},
	{ SidTypeComputer,       "COMPUTER"},
	{ SidTypeUnknown,        NULL}
};

void printSIDType( SID_NAME_USE use)
{
	SIDTYPENAME *ptr = nametbl;
	while( ptr->name != NULL){
		if( use == ptr->type){
			printf( ptr->name);
			return;
		}
		ptr++;
	}
	printf( "UNKNOWN");
}

int main( int argc, char **argv)
{
	if( argc < 2){
		fprintf( stderr, "Usage: id2sid <user or group ID>\n");
		return -1;
	}
	
	int rc = -1;
	
	// ȒP̂߁Cʂꍇɂ͑ΉĂȂ
	char sidBuf[256];
	SID *pSid = (SID *)sidBuf;
	DWORD sidLen = sizeof(sidBuf);
	char domBuf[256];
	LPTSTR domName = (LPTSTR)domBuf;
	DWORD domLen = sizeof(domBuf);
	SID_NAME_USE use;
	if( LookupAccountName( NULL, argv[1], pSid, &sidLen,
							domName, &domLen, &use) ){
		LPTSTR sidString;
		if( ConvertSidToStringSid( pSid, &sidString) ){
			printf( "SID:    %s\n", sidString);
			printf( "Domain: %s\n", domName);
			printf( "Type:   ");
			printSIDType( use);
			LocalFree( sidString);
			rc = 0;
		}
	}
	if( rc != 0)	fprintf( stderr, "Error: %lu\n", GetLastError() );
	return 0;
}